#ifndef _STUFF_H_
#define _STUFF_H_
#define ASSERT(x) __assert__(x,__FILE__,__LINE__)

#ifdef DEBUG
#define KEEP_MALLOC_STATS

extern size_t alloc_count;
extern size_t alloc_bytes;
extern size_t free_count;

#endif

#ifdef DEBUG
#define fn_free(x) _fn_free((void *)(x),__FILE__,__LINE__)
#define fn_malloc(x) _fn_malloc((x),__FILE__,__LINE__)
#define fn_realloc(x,s) _fn_realloc((void *)(x),(s),__FILE__,__LINE__)
#else
#define fn_free(x) _fn_free((x))
#define fn_malloc(x) _fn_malloc(x)
#define fn_realloc(x,s) _fn_realloc((void *)(x),(s))
#endif

#define file_exists(s) (get_file_size(s)>-1)
void __assert__(int,char *,int);
int expand_str(char **);
int get_file_size(char *);
int isalpha(char);
int isnum(char);
int isalphanum(char);
char *duplicate_str(char *);
void save_file(char *,char *,size_t);
char *read_file(char *);
char *convert_url_to_file(char *);
#ifdef DEBUG
void _fn_free(void *,char *,int);
void *_fn_malloc(size_t,char *,int);
void *_fn_realloc(void *,size_t,char *,int);
#else
void _fn_free(void *);
void *_fn_malloc(size_t size);
void *_fn_realloc(void *,size_t size);
#endif
void print_stats();

#endif //_STUFF_H_
